#-----------------------------------------------------------------------------
# Name:        Message.py
# Purpose:     
#
# Author:      Philipp Auersperg
#
# Created:     2003/10/01
# RCS-ID:      $Id: Message.py,v 1.2 2003/07/06 10:15:39 zworkb Exp $
# Copyright:   (c) 2003 BlueDynamics
# Licence:     GPL
#-----------------------------------------------------------------------------
import string

from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowAction
from DateTime import DateTime

from Products.CMFCore import CMFCorePermissions
import MessagePermissions

from Products.CMFDefault.NewsItem import NewsItem
from Products.CMFCore.utils import getToolByName    

#from Products.CMFPlone import transaction_note
from Products.CMFPlone.PloneFolder import PloneFolder

factory_type_information = (
    { 'id': 'Message',
      'content_icon': 'message_icon.gif',
      'meta_type': 'CMF Message',
      'description': 'a simple message product for CMF',
      'product': 'CMFMessage',
      'factory': 'addMessage',
      'immediate_view': 'message_edit_form',
      'actions': ({ 'id': 'view',
                    'name': 'View',
                    'action': 'message_view',
                    'permissions': (MessagePermissions.ViewMessages,) },
                  { 'id': 'edit',
                    'name': 'Edit',
                    'action': 'message_edit_form',
                    'permissions': (MessagePermissions.ChangeMessages,) },
                  )
      },
    )


def addMessage(self, id, subject='', description='', recipient='', sender='', text='', text_format='structured-text', fromUrl=None, REQUEST=None,):
    """object manager constructor"""
    o = Message(id, subject, description, sender=sender, text=text, text_format=text_format, fromUrl=fromUrl)
    self._setObject(id, o)
    
class Message(NewsItem):

    meta_type = 'CMF Message'

    security = ClassSecurityInfo()
    security.declareObjectProtected(CMFCorePermissions.View)
    
    def __init__( self
                  , id
                  #, title=''
                  , subject=''
                  , recipient = ''
                  , sender=''
                  , text=''
                  , description=''
                  , text_format='html'
                  , fromUrl=None
                  ):
        #traceback.print_stack()
        
        NewsItem.__init__( self, id=id, title=subject, text=text, description=description, text_format=text_format )
        self.recipient=recipient
        self.sender=sender
        self.fromUrl=fromUrl
        self.acknowledged=0

    #set security defaults
    setperm = security.setPermissionDefault
    setperm('View', ('Owner', 'Manager'))
    
    security.declareProtected(MessagePermissions.ChangeMessages, 'edit')
    def acknowledge(self,nextURL='',REQUEST=None):
        ''' acknowledge the message, then it isnt displayed any more in the box'''
        self.acknowledged=1
        if REQUEST:
            REQUEST.RESPONSE.redirect(nextURL)
    
    def isAcknowledged(self):
        ''' define if it is acknowledged '''
        return getattr(self,'acknowledged',0)
    
    def getSender(self):
        ''' '''
        return getattr(self,'sender',self.Creator())
    
    def getSubject(self):
        ''' '''
        return self.Title()
    
    security.declareProtected(MessagePermissions.ChangeMessages, 'edit')
    def edit( self
              , subject=None
              , description=None
              ):
        """ """
        if title:
            self.setTitle(subject)

        if description:
            self.setDescription(description)

        self.reindexObject()
        
    edit = WorkflowAction(edit)

InitializeClass(Message)
        

