#-----------------------------------------------------------------------------
# Name:        __init__.py
# Purpose:     
#
# Author:      Philipp Auersperg
#
# Created:     2003/10/01
# RCS-ID:      $Id: __init__.py,v 1.2 2003/07/06 10:15:39 zworkb Exp $
# Copyright:   (c) 2003 BlueDynamics
# Licence:     GPL
#-----------------------------------------------------------------------------

import Products.CMFCore
import sys


from Products.CMFCore import utils, CMFCorePermissions
from Products.CMFCore.DirectoryView import registerDirectory
import MessagePermissions
import Message
import MessageTool

this_module = sys.modules[ __name__ ]

contentConstructors = ( Message.addMessage, )
contentClasses = ( Message.Message, )

z_bases = utils.initializeBasesPhase1( contentClasses, this_module )

message_globals = globals()

registerDirectory( 'skins', globals() )
registerDirectory( 'skins/message', globals() )


tools = ( MessageTool.MessageTool,
          )
          
##__methods={
##    'sendPersonalMessage':Message.sendPersonalMessage,
##    'sendPersonalMessages':Message.sendPersonalMessages,
##}

def initialize( context ):
    utils.initializeBasesPhase2( z_bases, context )
    context.registerHelpTitle( 'CMF Message Help' )
    context.registerHelp( directory='help' )
    utils.ContentInit( 'CMF Message'
                       , content_types = contentClasses
#                       , permission = CMFCorePermissions.AddPortalContent
                       , permission = MessagePermissions.AddMessages
                       , extra_constructors = contentConstructors
                       , fti = Message.factory_type_information
                       ).initialize( context )

    utils.ToolInit( 'CMF Message Tool',
                    tools = tools,
                    product_name = 'CMFMessage',
                    icon='tool.gif' #'www/usertrack.gif'
                    ).initialize( context )
